//+-------------------------------------------------------------------------+
//|                                                PA candlestick v1.1.mq4  |
//+-------------------------------------------------------------------------+
#property copyright "brax64"
#property link      "http://www.forex-tsd.com"

#property indicator_chart_window

extern string note1          = "Candles = bars included the current";
extern int    Candles        = 5;
extern color  Up_power_color = Lime;
extern color  Dn_power_color = Red;
extern color  Bkgrnd_Color   = DimGray;
extern int    Pan_X          = 10;
extern int    Pan_Y          = 10;


double Up[], Dn[];
string ID = "B_B Power v1.1";

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
{
   IndicatorBuffers(2); 
   IndicatorShortName("PA candlestick v1.1");
   SetIndexBuffer(0,Up); SetIndexStyle(0,DRAW_NONE);
   SetIndexBuffer(1,Dn); SetIndexStyle(1,DRAW_NONE);
    
   return(0);
}

int deinit()
{
   string lookFor       = ID;
   int    lookForLength = StringLen(lookFor);   
   for(int i = ObjectsTotal() - 1; i >= 0; i--)
   {
      string name = ObjectName(i);
         if(StringSubstr(name, 0, lookForLength) == lookFor) ObjectDelete(name);
   }
   return(0);
}

//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
{   
   int dig = MarketInfo(Symbol(), MODE_DIGITS);
   int modifier = 1;
   if(dig == 3 || dig == 5) modifier = 10;
   double factor = Point * modifier;
   
   double upsum = 0;
   double dnsum = 0;
   
   for(int i = 0; i <= (Candles - 1); i++)
   {
      if(Close[i] >= Open[i]) {Up[i] = (High[i] - Close[i]); Dn[i] = (Open[i]  - Low[i]);}
      else                    {Up[i] = (High[i] - Open[i]);  Dn[i] = (Close[i] - Low[i]);}
      
      upsum = upsum + Up[i];
      dnsum = dnsum + Dn[i];
      
   }     

   double bullpower = (dnsum/upsum);
   double bearpower = (upsum/dnsum);

   ObjectCreate (ID + "_00", OBJ_LABEL, 0, 0, 0);
   ObjectSetText(ID + "_00", "ggg", 40, "Webdings");
       ObjectSet(ID + "_00", OBJPROP_CORNER, 0);
       ObjectSet(ID + "_00", OBJPROP_XDISTANCE, Pan_X);
       ObjectSet(ID + "_00", OBJPROP_YDISTANCE, Pan_Y);      
       ObjectSet(ID + "_00", OBJPROP_COLOR, Bkgrnd_Color);
       ObjectSet(ID + "_00", OBJPROP_BACK, false);
   
   ObjectCreate (ID + "Bull0", OBJ_LABEL, 0, 0, 0);
   ObjectSetText(ID + "Bull0", CharToStr(233), 18, "Wingdings", Up_power_color);
       ObjectSet(ID + "Bull0", OBJPROP_CORNER, 0);
       ObjectSet(ID + "Bull0", OBJPROP_XDISTANCE, 5 + Pan_X);
       ObjectSet(ID + "Bull0", OBJPROP_YDISTANCE, 0 + Pan_Y);
       ObjectSet(ID + "Bull0", OBJPROP_BACK, false);
   
   ObjectCreate (ID + "Bull1", OBJ_LABEL, 0, 0, 0);
   ObjectSetText(ID + "Bull1", DoubleToStr(bullpower,2), 16, "Verdana Bold", Up_power_color);
       ObjectSet(ID + "Bull1", OBJPROP_CORNER, 0);
       ObjectSet(ID + "Bull1", OBJPROP_XDISTANCE, 35 + Pan_X);
       ObjectSet(ID + "Bull1", OBJPROP_YDISTANCE, 2  + Pan_Y);
       ObjectSet(ID + "Bull1", OBJPROP_BACK, false);
   
   ObjectCreate (ID + "Bear0", OBJ_LABEL, 0, 0, 0);
   ObjectSetText(ID + "Bear0", CharToStr(234), 18, "Wingdings", Dn_power_color);
       ObjectSet(ID + "Bear0", OBJPROP_CORNER, 0);
       ObjectSet(ID + "Bear0", OBJPROP_XDISTANCE, 5  + Pan_X);
       ObjectSet(ID + "Bear0", OBJPROP_YDISTANCE, 30 + Pan_Y);
       ObjectSet(ID + "Bear0", OBJPROP_BACK, false);
   
   ObjectCreate (ID + "Bear1", OBJ_LABEL, 0, 0, 0);
   ObjectSetText(ID + "Bear1", DoubleToStr(bearpower,2), 16, "Verdana Bold", Dn_power_color);
       ObjectSet(ID + "Bear1", OBJPROP_CORNER, 0);
       ObjectSet(ID + "Bear1", OBJPROP_XDISTANCE, 35 + Pan_X);
       ObjectSet(ID + "Bear1", OBJPROP_YDISTANCE, 28 + Pan_Y);
       ObjectSet(ID + "Bear1", OBJPROP_BACK, false);
   
   ObjectCreate (ID + "_01", OBJ_LABEL, 0, 0, 0);
   ObjectSetText(ID + "_01", "Bars: " + Candles, 10, "Verdana Bold Italic", WhiteSmoke);
       ObjectSet(ID + "_01", OBJPROP_CORNER, 0);
       ObjectSet(ID + "_01", OBJPROP_XDISTANCE, 95 + Pan_X);
       ObjectSet(ID + "_01", OBJPROP_YDISTANCE, 3  + Pan_Y);
       ObjectSet(ID + "_01", OBJPROP_BACK, false);
   
   ObjectCreate (ID + "_02", OBJ_LABEL, 0, 0, 0);
   ObjectSetText(ID + "_02", "Up: " + DoubleToStr(upsum/factor,1), 10, "Verdana Bold Italic", WhiteSmoke);
       ObjectSet(ID + "_02", OBJPROP_CORNER, 0);
       ObjectSet(ID + "_02", OBJPROP_XDISTANCE, 95 + Pan_X);
       ObjectSet(ID + "_02", OBJPROP_YDISTANCE, 19 + Pan_Y);
       ObjectSet(ID + "_02", OBJPROP_BACK, false);
   
   ObjectCreate (ID + "_03", OBJ_LABEL, 0, 0, 0);
   ObjectSetText(ID + "_03", "Dn: " + DoubleToStr(dnsum/factor,1), 10, "Verdana Bold Italic", WhiteSmoke);
       ObjectSet(ID + "_03", OBJPROP_CORNER, 0);
       ObjectSet(ID + "_03", OBJPROP_XDISTANCE, 95 + Pan_X);
       ObjectSet(ID + "_03", OBJPROP_YDISTANCE, 35 + Pan_Y);
       ObjectSet(ID + "_03", OBJPROP_BACK, false);
   
   return(0);
}